---
- name: import default values
  ansible.builtin.import_role:
    name: "{{ ansible_collection_name }}.defaults"

- name: launch first server
  become: true
  ansible.builtin.service:
    enabled: true
    name: "rke2-server"
    state: started
  when: inventory_hostname == groups[kubernetes_rke2_control_group][0]

- name: wait for k8s api to be up on first server
  ansible.builtin.wait_for:
    port: 6443
    timeout: 900
    state: started
  when: inventory_hostname == groups[kubernetes_rke2_control_group][0]

- name: wait for node onboarding listener to be up on first server
  ansible.builtin.wait_for:
    host: "{{ kubernetes_main_address }}"
    port: 9345
    timeout: 900
    state: started

- name: launch other servers
  become: true
  ansible.builtin.service:
    enabled: true
    name: "rke2-server"
    state: started
  when: inventory_hostname in groups[kubernetes_rke2_control_group] and
        inventory_hostname != groups[kubernetes_rke2_control_group][0]

- name: launch workers
  become: true
  ansible.builtin.service:
    enabled: true
    name: "rke2-agent"
    state: started
  when: inventory_hostname in groups[kubernetes_rke2_worker_group] and
        inventory_hostname not in groups[kubernetes_rke2_control_group]

- name: remove artifacts file
  become: true
  ansible.builtin.file:
    name: "{{ kubernetes_rke2_debian_images_path }}"
    state: absent
  when: ansible_os_family | lower == 'debian'
